<script>
// import { ValidationObserver } from 'vee-validate'
// import {
//   BAlert, BButton, BCol, BForm, BFormGroup, BFormInput, BRow, BSpinner,
// } from 'bootstrap-vue'
// import { email, required } from '@validations'
import UserApiV1 from '@/api/userApi'

export default {
  name: 'EditUserForm',
  components: {
    ValidationObserver,
    BAlert,
    BForm,
    BRow,
    BCol,
    BFormGroup,
    BFormInput,
    BButton,
    BSpinner,
  },
  props: {
    ldapData: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    return {
      user: { username: '', rol: '' },
      optionsRol: [
        { value: null, text: 'Please select some item' },
        { value: 'USER', text: 'Operator' },
        { value: 'DEVELOPER', text: 'Developer' },
        { value: 'ADMIN', text: 'Administrator' },
      ],
      required,
      email,
      saving: false,
      isRequest: false,
      isError: false,
      requestMessage: '',
    }
  },
  computed: {
    alertToggleVariant() {
      return this.isError ? 'danger' : 'success'
    },
    alertToggleText() {
      return this.isError ? 'Error!' : 'Success!'
    },
    prepareOptionsRol() {
      const options = this.optionsRol
      if (this.user.rol.toLowerCase() === 'root')
        options.push({ value: 'ROOT', text: 'root' })

      return options
    },
  },
  mounted() {
    this.user = this.$store.state.user
  },
  methods: {
    async saveUser() {
      this.saving = true
      console.log('this.ldapData: ', this.ldapData)

      const users = new UserApiV1()
      try {
        this.responseldapData = await users.updateUser(this.ldapData)
        console.log('responseldapData: ', JSON.parse(JSON.stringify(this.responseldapData.data)))
        this.requestMessage = this.responseldapData.data.message
        this.isError = false
      }
      catch (error) {
        console.log('error getUserById', error)
        this.requestMessage = error.response.data.message
        this.isError = true
      }
      this.saving = false
      this.isRequest = true
    },
  },
}
</script>

<template>
  <ValidationObserver ref="simpleRules">
    <BForm class="mt-2">
      <BRow>
        <!-- username -->
        <BCol sm="6">
          <BFormGroup
            label="Username"
            label-for="username"
          >
            <BFormInput
              v-model="ldapData.username"
              placeholder="Enter Username"
              name="username"
              required
            />
            <small
              id="usernameHelp"
              class="form-text text-muted"
            >
              User identifier (e.g., uid, userid, sAMAccountName)
            </small>
          </BFormGroup>
        </BCol>

        <!-- email -->
        <BCol sm="6">
          <BFormGroup
            label="Email"
            label-for="email"
          >
            <BFormInput
              v-model="ldapData.email"
              placeholder="Enter Email"
              name="email"
              required
            />
            <small
              id="emailHelp"
              class="form-text text-muted"
            >
              Email address (e.g., mail, email, userPrincipalName)
            </small>
          </BFormGroup>
        </BCol>

        <!-- name -->
        <BCol sm="6">
          <BFormGroup
            label="Name"
            label-for="name"
          >
            <BFormInput
              v-model="ldapData.name"
              placeholder="Enter Name"
              name="name"
              required
            />
            <small
              id="nameHelp"
              class="form-text text-muted"
            >
              Full name attribute (e.g., cn, displayName)
            </small>
          </BFormGroup>
        </BCol>

        <!-- first_name -->
        <BCol sm="6">
          <BFormGroup
            label="First Name"
            label-for="first_name"
          >
            <BFormInput
              v-model="ldapData.first_name"
              placeholder="Enter First Name"
              name="first_name"
              required
            />
            <small
              id="firstNameHelp"
              class="form-text text-muted"
            >
              First name attribute (e.g., givenName)
            </small>
          </BFormGroup>
        </BCol>

        <!-- last_name -->
        <BCol sm="6">
          <BFormGroup
            label="Last Name"
            label-for="last_name"
          >
            <BFormInput
              v-model="ldapData.last_name"
              placeholder="Enter Last Name"
              name="last_name"
              required
            />
            <small
              id="lastNameHelp"
              class="form-text text-muted"
            >
              Last name attribute (e.g., sn)
            </small>
          </BFormGroup>
        </BCol>

        <BCol md="12">
          <BAlert
            v-if="isRequest"
            :variant="alertToggleVariant"
            show
          >
            <div class="alert-body">
              <FeatherIcon
                icon="InfoIcon"
                class="mr-50"
              />
              <span><strong>{{ alertToggleText }}</strong> {{ requestMessage }}.</span>
            </div>
          </BAlert>
        </BCol>

        <BCol cols="12">
          <BButton
            variant="primary"
            class="mt-2 mr-1"
            :disabled="saving"
            @click="saveUser"
          >
            <BSpinner
              v-if="saving"
              small
            />
            <span v-if="saving"> Saving... </span>
            <span v-else> Save changes </span>
          </BButton>
        </BCol>
      </BRow>
    </BForm>
  </ValidationObserver>
</template>

<style scoped>

</style>
